"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.findPath = exports.findPaths = void 0;
const safe_1 = require("../safe");
function findPaths(options) {
    function test(path, propertyName) {
        // @ts-expect-error
        const property = options?.[propertyName] || undefined;
        if (!property) {
            return true;
        }
        if (typeof property === "string") {
            // @ts-expect-error
            return property === path[propertyName];
        }
        else {
            // @ts-expect-error
            return property.test(path[propertyName]);
        }
    }
    const filePaths = (0, safe_1.getPaths)();
    if (!options) {
        return filePaths;
    }
    return filePaths.filter((path) => {
        return (test(path, "name") &&
            test(path, "extension") &&
            test(path, "folder") &&
            test(path, "root"));
    });
}
exports.findPaths = findPaths;
function findPath(options) {
    return findPaths(options)[0];
}
exports.findPath = findPath;
