"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.storeFolderPaths = exports.storePaths = exports.storedPath = void 0;
const filePath_1 = require("../class/filePath");
const safe_1 = require("../safe");
const readers_1 = require("./readers");
function storedPath(path) {
    return (0, safe_1.getPaths)().some((fp) => fp.fullPath === path);
}
exports.storedPath = storedPath;
function storePaths(paths) {
    const newPaths = (0, safe_1.getPaths)();
    const length = paths.length;
    for (let i = 0; i < length; i++) {
        const path = paths[i];
        if (storedPath(path)) {
            continue;
        }
        const filePath = new filePath_1.FilePath(path);
        newPaths.push(filePath);
    }
    (0, safe_1.setPaths)(newPaths);
}
exports.storePaths = storePaths;
async function storeFolderPaths(folderPaths, options = {
    deepSearch: true
}) {
    if (!folderPaths) {
        folderPaths = await (0, readers_1.readWorkspaceFolderNames)();
    }
    if (folderPaths.length === 1) {
        const filePaths = await (0, readers_1.readFolderPaths)(folderPaths[0], options);
        storePaths(filePaths);
        return;
    }
    const filePaths = await Promise.all(folderPaths.map(async (path) => await (0, readers_1.readFolderPaths)(path, options)));
    storePaths(filePaths.flat());
}
exports.storeFolderPaths = storeFolderPaths;
